#include "Stack_Of_Cover.h"

using namespace std;

// Add a new pair of <cover/current sigma1>
void Stack_Of_Cover::Emplier_Cover_Sigma_1_(Cover *C_, vector <int> sigma1){
	Covers_.push_back(C_);		
	Sigmas_1_.push_back(sigma1);
	//Sigmas_0_.push_back(sigma_0);
}

// delete the pair <cover/sigma1> in the top of the stack
void Stack_Of_Cover::Depiler_Cover_Sigma_1_(){
	Covers_.pop_back();
	Sigmas_1_.pop_back();
	//Sigmas_0_.pop_back();
}

// test if current sigma_1 is included on sigma_1 in the top of the stack
bool Stack_Of_Cover::Inlcus(vector <int> sigma_1_Current){
    return std::includes(sigma_1_Current.begin(), sigma_1_Current.end(), Sigmas_1_[Sigmas_1_.size()-1].begin(), Sigmas_1_[Sigmas_1_.size()-1].end());
}

// test if current sigma_1 is equal to sigma_1 in the top of the stack
bool Stack_Of_Cover::Egaux(vector <int> sigma_1_Current){
	if(Sigmas_1_[Sigmas_1_.size()-1] == sigma_1_Current)
		return true;
	else
		return false;		
}

// new items of sigma = current sigma_1 \ sigma_1 in the top of the stack
vector <int> Stack_Of_Cover::Diffrence_Sigma_1(vector <int> sigma_1_Current){
	vector <int> diff_Elts;
	set_symmetric_difference(Sigmas_1_[Sigmas_1_.size()-1].begin(), Sigmas_1_[Sigmas_1_.size()-1].end(), sigma_1_Current.begin(), sigma_1_Current.end(), back_inserter(diff_Elts));
	return diff_Elts;
}

// new items of sigma = current sigma_0 \ sigma_0 in the top of the stack
//vector <int> Stack_Of_Cover::Diffrence_Sigma_0(vector <int> sigma_0_Current){
//	vector <int> diff_Elts;
//	set_symmetric_difference(Sigmas_0_[Sigmas_0_.size()-1].begin(), Sigmas_0_[Sigmas_0_.size()-1].end(), sigma_0_Current.begin(), sigma_0_Current.end(), back_inserter(diff_Elts));
//	return diff_Elts;
//}
